#include "fxlib.h"
#include "stdlib.h"

#define MAXFUEL 1000
#define MAXENNEMI 200

typedef enum{HELICO1, AVION1, HELICO2, AVION2, TANK} TypeEnnemi;

typedef struct
{
	char x, y, dx;
	int temps, tempsBombe;
	TypeEnnemi type;
} Ennemi;

typedef struct
{
	char x, y, dx, dy, type, rebond;
} Bombe;

typedef struct
{
	char x, y, temps, n;
} Explosion;

char* VRam_Base(); //syscall donnant l'adresse de la VRAM

int time(); //donne le nombre de secondes coules depuis le dbut de la journe.

char* int2str(char* c, unsigned int n)
{
    if(n==0)
    {
        c[0] = '0';
        c[1] = 0;
    }
    else
    {
        int i, l=0;
        for(i=n ; i ; i/=10)
            l++;
        c[l] = 0;
        for(i=n ; i ; i/=10)
            c[--l] = i%10+'0';
    }
    return c;
}

void DrawSprite8(unsigned char *sprite, int x, int y)
{
    unsigned short ligne;
    char i, decalage, debut = 0, fin = 8, *ecran, *adresseLigne = (char*)&ligne;
    if(x < -7 || x > 119) return;
    decalage = 8 - x%8;
    if(y < 0) debut = -y;
    if(y > 56) fin -= y-56;
	ecran = (char*)(VRam_Base() + 16*(y+debut) + x/8);
	for(i=debut ; i<fin ; i++)
	{
		ligne = sprite[i] << decalage;
		ecran[0] |= adresseLigne[0];
		if(x<=112) ecran[1] |= adresseLigne[1];
		ecran += 16;
	}
}
void DrawSpriteReverse(unsigned char *sprite, int x, int y)
{
    unsigned short ligne;
    char i, decalage, *ecran, *adresseLigne = (char*)&ligne;
    decalage = 8 - x%8;
	ecran = (char*)(VRam_Base() + 16*y + x/8);
	for(i=0 ; i<8 ; i++)
	{
		ligne = ~(sprite[i] << decalage);
		ecran[0] &= adresseLigne[0];
		ecran[1] &= adresseLigne[1];
		ecran += 16;
	}
}

void dessinJauges(int fuel, int xp) // les deux nombres reus sont des poucentages
{
	char *vram, i;
	static char alterne=0;
	alterne = (alterne+1)%8;
	if(xp>100) xp=100;
	vram = VRam_Base();
	for(i=0 ; i<64 ; i++) vram[i*16+15] = 128;
		fuel = fuel*64/100;
	if(fuel>25 || alterne<3)
		for(i=0 ; i<fuel ; i++) vram[(64-i)*16+15] |= 48;
	xp = xp*64/100;
	for(i=0 ; i<xp ; i++) vram[(64-i)*16+15] |= 6;
}

void supprEnnemi(Ennemi *ennemi, int n, int nb)
{
	int i;
	for(i=n ; i<nb-1 ; i++)
		ennemi[i] = ennemi[i+1];
}

void supprBombe(Bombe *bombe, int n, int nb)
{
	int i;
	for(i=n ; i<nb-1 ; i++)
		bombe[i] = bombe[i+1];
}

void supprExplosion(Explosion *explosion, int n, int nb)
{
	int i;
	for(i=n ; i<nb-1 ; i++)
		explosion[i] = explosion[i+1];
}

void statistiques(const char* message, int level, int xp, int maxcombo, int maxheight)
{
	int key=0;
	char symbole_infini[] = {0x7F, 0x53, 0}, str[8];
	Bdisp_AllClr_VRAM();
	PopUpWin(6);
	PrintXY((128-strlen(message)*6)/2, 6, message, 0);
	PrintMini(25, 18, "Level      :", 1);
	if(level==100)	PrintMini(80, 18, symbole_infini, 1);
	else			PrintMini(80, 18, int2str(str, level), 1);
	PrintMini(25, 26, "Experience :", 1);
	if(level==100)	PrintMini(80, 26, symbole_infini, 1);
	else			PrintMini(80, 26, int2str(str, xp), 1);
	PrintMini(25, 34, "Max combo :", 1);
	PrintMini(80, 34, int2str(str, maxcombo), 1);
	PrintMini(25, 42, "Max height :", 1);
	PrintMini(80, 42, int2str(str, maxheight), 1);
	PrintMini(46, 52, "Press EXE", 1);
	while(key != KEY_CTRL_EXE) GetKey(&key);
}

int xpPourFinirLevel(int level)
{
//dans le jeu original, la fonction est  peu prs 2x^3-21x^2+118x-26
	return 3*level*level*level-10*level*level+100*level;
}

void jeu(int niveau)
{
	int level=1, i, j, x=60, y=48, dx=0, dy=0, fuel, xp, argent=0, nbEnnemi=0, nbBombe=0, nbExplosion=0;
	int ennemisAchetes[5]={5}, combo=0, scorecombo=0, maxcombo=0, maxheight=0;
	char decalageSol=0, alterne=0, str[8], ennemiXP[]={10,15,20,25,10}, toutAchete=0;
	Ennemi ennemi[MAXENNEMI+1];
	Bombe bombe[MAXENNEMI+1];
	Explosion explosion[MAXENNEMI+1];
	char tank[] = {0,0,112,127,120,126,165,126};
	char helico1D[] = {95,228,94,113,127,18,63,0};
	char helico1G[] = {250,39,122,142,254,72,252,0};
	char helico2D[] = {95,228,94,127,127,18,63,0};
	char helico2G[] = {250,39,122,254,254,72,252,0};
	char avion1D[] = {128,192,254,253,127,56,48,0};
	char avion1G[] = {1,3,127,191,254,28,12,0};
	char avion2D[] = {128,192,254,255,127,56,48,0};
	char avion2G[] = {1,3,127,255,254,28,12,0};
	char tank2D[] = {0,0,224,158,144,255,165,126};
	char tank2G[] = {0,0,7,121,9,255,165,126};
	//char sol[] = {255,221,136,221,255,221,187,17};
	char sol[] = {255,54,235,150,114,91,199,84};
	char bombe1[] = {144,240,240,96,0,0,0,0};
	char bombe2[] = {96,144,144,96,0,0,0,0};
	char bombe3[] = {64,112,224,32,0,0,0,0};
	char bombe4[] = {96,240,240,96,0,0,0,0};
	char fleche1[] = {16,56,124,254,254,0,0,0};
	char fleche2[] = {16,56,124,0,0,0,0,0};
	char explosion1[] = {0,44,82,74,129,110,48,0};
	char explosion2[] = {6,105,66,136,2,33,132,99};
	char explosion3[] = {8,65,16,132,0,0,17,130};

	while(level) //boucle principale
	{
		fuel = MAXFUEL;
		xp = 0;
		for(i=HELICO1 ; i<=TANK ; i++) //cration des ennemis pour le niveau
		{
			for(j=0 ; j<4*ennemisAchetes[i] ; j++)
			{
				if(nbEnnemi < MAXENNEMI)
				{
					ennemi[nbEnnemi].type = i;
					if(i!=TANK) ennemi[nbEnnemi].y = rand()%30+5;
					else ennemi[nbEnnemi].y = 48;
					if(rand()%2)
					{
						ennemi[nbEnnemi].x = -8;
						ennemi[nbEnnemi].dx = rand()%2+1;
					}
					else
					{
						ennemi[nbEnnemi].x = 120;
						ennemi[nbEnnemi].dx = rand()%2-2;
					}
					ennemi[nbEnnemi].temps = rand()%MAXFUEL;
					if(i!=TANK) ennemi[nbEnnemi].tempsBombe = ennemi[nbEnnemi].temps-(rand()%80)/abs(ennemi[nbEnnemi].dx)-16;
					else ennemi[nbEnnemi].tempsBombe=-1; //pas de bombe pour les tanks
					if(i==AVION2 && rand()%2) ennemi[nbEnnemi].tempsBombe=-1; //les homer ont une chance sur deux de tirer.
					nbEnnemi++;
				}
			}
		}
		while(fuel && xp<xpPourFinirLevel(level)) // boucle du niveau
		{
//mouvements
			if(alterne==0) //alterne 0 et 1 pour que les ennemis ne bougent qu'une fois sur 2
			{
				fuel--;
				dx-=5*dx/abs(dx); //on fait ralentir le tank
				dy+=3;
				for(i=0 ; i<nbEnnemi ; i++)
				{
					if(ennemi[i].temps>fuel)
					{
						ennemi[i].temps = MAXFUEL+1;
						ennemi[i].x += ennemi[i].dx;
						if(ennemi[i].tempsBombe == fuel) //si oui, l'ennemi large sa bombe
						{
							bombe[nbBombe].x = ennemi[i].x+2;
							bombe[nbBombe].y = ennemi[i].y+6;
							bombe[nbBombe].type = ennemi[i].type;
							bombe[nbBombe].dx = 0;
							bombe[nbBombe].dy = 0;
							bombe[nbBombe].rebond = 0;
							if(bombe[nbBombe].type > 1) // pour les bombes 3 et 4
							{
								if(bombe[nbBombe].type!=2 && abs(x-bombe[nbBombe].x) > abs(y-bombe[nbBombe].y)/2) bombe[nbBombe].dx = (x<bombe[nbBombe].x)?-5:5; //pas de direction horizontale pour les bombes 3
								else if (abs(y-bombe[nbBombe].y) > abs(x-bombe[nbBombe].x)/2) bombe[nbBombe].dy = (y<bombe[nbBombe].y)?-5:5;
								else
								{
									bombe[nbBombe].dx = (x<bombe[nbBombe].x)?-5:5;
									bombe[nbBombe].dy = (y<bombe[nbBombe].y)?-5:5;
								}
							}
							nbBombe++;
							if(nbBombe > MAXENNEMI) nbBombe = MAXENNEMI;
						}
						if(ennemi[i].x<=-8 || ennemi[i].x>=120)
						{
							supprEnnemi(ennemi, i, nbEnnemi);
							nbEnnemi--;
							i--;
						}
					}
				}
				for(i=0 ; i<nbBombe ; i++)
				{
					if(bombe[i].type > 1) //pour les bombes 3 et 4
					{
						bombe[i].x += bombe[i].dx/2;
						bombe[i].y += bombe[i].dy/2;
						if(bombe[i].type == 3) //bombe 4 uniquement
						{
							if(abs(x-bombe[i].x) > abs(y-bombe[i].y))
							{
								if(x < bombe[i].x) { if(bombe[i].dx > -5) bombe[i].dx--; }
								else { if(bombe[i].dx < 5) bombe[i].dx++; }
							}
							else
							{
								if(y < bombe[i].y) { if(bombe[i].dy > -5) bombe[i].dy--; }
								else { if(bombe[i].dy < 5) bombe[i].dy++; }
							}
						}
						if(bombe[i].x<=-4 || bombe[i].x>=120 || bombe[i].y<=-4 || bombe[i].y>=53)
						{
							supprBombe(bombe, i, nbBombe);
							nbBombe--;
							i--;
						}
					}
					else //bombes 1 et 2
					{
						bombe[i].y += bombe[i].dy/3;
						bombe[i].dy++;
						if(bombe[i].y > 52)
						{
							if(bombe[i].type==1 && bombe[i].rebond<1) //si oui elle rebondit, bombe 2 uniquement
							{
								bombe[i].y = 52;
								bombe[i].dy = bombe[i].dy*(-2)/3;
								bombe[i].rebond++;
							}
							else
							{
								supprBombe(bombe, i, nbBombe);
								nbBombe--;
								i--;
							}
						}
					}
				}
				for(i=0 ; i<nbExplosion ; i++)
				{
					explosion[i].temps--;
					if(explosion[i].temps == 0)
					{
						supprExplosion(explosion, i, nbExplosion);
						nbExplosion--;
						i--;
					}
				}
				alterne = 2;
			}
			alterne--;
//collisions
			for(i=0 ; i<nbEnnemi ; i++) //collision avec les ennemis
			{
				if(abs(x-ennemi[i].x)<8 && abs(y-ennemi[i].y)<8)
				{
					dy = -30;
					dx = (x-ennemi[i].x)*5;
					xp += ennemiXP[ennemi[i].type];
					scorecombo += ennemiXP[ennemi[i].type];

					explosion[nbExplosion].x = ennemi[i].x;
					explosion[nbExplosion].y = ennemi[i].y;
					explosion[nbExplosion].temps = 10;
					explosion[nbExplosion].n = ++combo;
					if(combo > maxcombo) maxcombo=combo;
					nbExplosion++;
					if(nbExplosion > MAXENNEMI) nbExplosion = MAXENNEMI;

					supprEnnemi(ennemi, i, nbEnnemi);
					nbEnnemi--;
					i--;
				}
			}
			for(i=0 ; i<nbBombe ; i++) //collision avec les bombes
			{
				if(abs(x-bombe[i].x)<8 && abs(y-bombe[i].y)<8)
				{
					dy = -40;
					dx = (x-bombe[i].x+2)*4; //+2 car les bombes font 4*4 pixels
					supprBombe(bombe, i, nbBombe);
					nbBombe--;
					i--;
				}
			}
//dplacement du tank
			if(IsKeyDown(KEY_CTRL_LEFT) && dx>-20) dx-=4;
			if(IsKeyDown(KEY_CTRL_RIGHT) && dx<20) dx+=4;
			if(IsKeyDown(KEY_CTRL_EXIT)) statistiques("Pause", level, xp, maxcombo, maxheight);
			x+=dx/10;
			y+=dy/10;
			if(y>48) //rebond au sol
			{
				y=48;
				dy = dy*(-2)/3;
				xp += scorecombo*(combo-1)/10;
				combo = scorecombo = 0;
			}
			if(48-y > maxheight) maxheight = 48-y; //enregistrer la hauteur max
			if(x<0) {x=0; dx*=-1; }
			if(x>112) {x=112; dx*=-1; }
//dessin
			Bdisp_AllClr_VRAM();
			if(toutAchete) dessinJauges(100, 0); //dessin des jauges
			else dessinJauges(fuel*100/MAXFUEL, xp*100/xpPourFinirLevel(level));

			decalageSol = (decalageSol+1)%16;
			for(i=0 ; i<16 ; i++) DrawSprite8(sol, i*8-decalageSol/2, 56); //dessin du sol

			if(y>-8)DrawSprite8(tank, x, y); //dessin du tank
			else
			{
				PrintMini(x, 8, int2str(str, 48-y), 1);
				if(y>-30) DrawSprite8(fleche1, x, 0);
				else DrawSprite8(fleche2, x, 0);
			}

			for(i=0 ; i<nbEnnemi ; i++) //dessin des ennemis
			{
				if(ennemi[i].temps>fuel)
				{
					if(ennemi[i].dx>0)
					{
						switch(ennemi[i].type)
						{
							case HELICO1: DrawSprite8(helico1D, ennemi[i].x, ennemi[i].y); break;
							case AVION1: DrawSprite8(avion1D, ennemi[i].x, ennemi[i].y); break;
							case HELICO2: DrawSprite8(helico2D, ennemi[i].x, ennemi[i].y); break;
							case AVION2: DrawSprite8(avion2D, ennemi[i].x, ennemi[i].y); break;
							case TANK: DrawSprite8(tank2D, ennemi[i].x, ennemi[i].y); break;
						}
					}
					else
					{

						switch(ennemi[i].type)
						{
							case HELICO1: DrawSprite8(helico1G, ennemi[i].x, ennemi[i].y); break;
							case AVION1: DrawSprite8(avion1G, ennemi[i].x, ennemi[i].y); break;
							case HELICO2: DrawSprite8(helico2G, ennemi[i].x, ennemi[i].y); break;
							case AVION2: DrawSprite8(avion2G, ennemi[i].x, ennemi[i].y); break;
							case TANK: DrawSprite8(tank2G, ennemi[i].x, ennemi[i].y); break;
						}
					}
				}
			}
			for(i=0 ; i<nbBombe ; i++) //dessin des bombes
			{
				switch(bombe[i].type)
				{
					case HELICO1: DrawSprite8(bombe1, bombe[i].x, bombe[i].y); break;
					case AVION1: DrawSprite8(bombe2, bombe[i].x, bombe[i].y); break;
					case HELICO2: DrawSprite8(bombe3, bombe[i].x, bombe[i].y); break;
					case AVION2: DrawSprite8(bombe4, bombe[i].x, bombe[i].y); break;
				}
			}
			for(i=0 ; i<nbExplosion ; i++) //dessin des explosions
			{
				if(explosion[i].temps > 7) DrawSprite8(explosion1, explosion[i].x, explosion[i].y);
				else if(explosion[i].temps > 4) DrawSprite8(explosion2, explosion[i].x, explosion[i].y);
				else DrawSprite8(explosion3, explosion[i].x, explosion[i].y);
				PrintMini(explosion[i].x, explosion[i].y-8, int2str(str, explosion[i].n), 1);
			}

			Bdisp_PutDisp_DD();
			Sleep(10*(3-niveau));
		}
		if(!toutAchete)
		{
			if(fuel) //next level
			{
				int key=0, curseur=0;
				char prix[]={10 ,30, 20, 40, 50};

				for(i=0 ; i<nbEnnemi ; i++) //suppressions des ennemis restants qui ne sont pas encore entrs dans l'cran
				{
					if(ennemi[i].temps<fuel)
					{
						supprEnnemi(ennemi, i, nbEnnemi);
						nbEnnemi--;
						i--;
					}
				}
				argent += xp;
				while(key != KEY_CTRL_EXE)
				{
					Bdisp_AllClr_VRAM();
					PrintXY(37, 1, "Level Up!", 0);
					PrintMini(1, 10, "Exp left:", 1);
					PrintMini(67, 10, "Freq - Cost", 1);
					PrintMini(1, 59, "[F1] Buy   [Exe] Continue", 1);
					PrintMini(40, 10, int2str(str, argent), 1);
					DrawSprite8(helico1D, 10, 17); PrintMini(25, 17, "Bomber", 1);
					DrawSprite8(avion1D, 10, 25); PrintMini(25, 25, "Bouncer", 1);
					DrawSprite8(helico2D, 10, 33); PrintMini(25, 33, "Gunner", 1);
					DrawSprite8(avion2D, 10, 41); PrintMini(25, 41, "Homer", 1);
					DrawSprite8(tank2D, 10, 49); PrintMini(25, 49, "Miner", 1);
					DrawSprite8(bombe2, 5, 8*curseur+19);
					for(i=0 ; i<5 ; i++)
					{
						PrintMini(75, 8*i+17, int2str(str, ennemisAchetes[i]), 1);
						if(ennemisAchetes[i]<10)
							PrintMini(100, 8*i+17, int2str(str, prix[i]*(ennemisAchetes[i]+1)), 1);
					}
					GetKey(&key);
					switch(key)
					{
						case KEY_CTRL_UP:
							if(curseur)
								curseur--;
							break;
						case KEY_CTRL_DOWN:
							if(curseur<4)
								curseur++;
							break;
						case KEY_CTRL_F1:
							if(ennemisAchetes[curseur]<10 && argent>=prix[curseur]*(ennemisAchetes[curseur]+1))
							{
								int i, somme=0;
								argent -= prix[curseur]*(ennemisAchetes[curseur]+1);
								ennemisAchetes[curseur]++;
								for(i=0 ; i<5 ; i++) somme += ennemisAchetes[i]; //on vrifie si le joueur a tout achet
								if(somme == 5*10)
								{
									toutAchete = 1;
									level = 99;
									Bdisp_AllClr_VRAM();
									PrintMini(1, 1, "Well done! You have maxed out", 1);
									PrintMini(1, 8, "the frequency levels of all the", 1);
									PrintMini(1, 15, "enemies.", 1);
									PrintMini(1, 22, "Now the real challenge begins!", 1);
									PrintMini(1, 29, "You now have unlimited fuel,", 1);
									PrintMini(1, 36, "so don't rush yourfelf,", 1);
									PrintMini(1, 43, "see if you can reach the top", 1);
									PrintMini(1, 50, "of high and combo. Good Game!", 1);
									while(key != KEY_CTRL_EXE) GetKey(&key);
								}
							}
							break;
					}
				}
				level++;
			}
			else
			{
				statistiques("Game Over", level, xp, maxcombo, maxheight);
				level=0;
			}
		}
	}
}

void help()
{
	int key, i, page=0;
	char tank[] = {0,0,112,127,120,126,165,126};
	char helico1D[] = {95,228,94,113,127,18,63,0};
	char helico2D[] = {95,228,94,127,127,18,63,0};
	char avion1D[] = {128,192,254,253,127,56,48,0};
	char avion2D[] = {128,192,254,255,127,56,48,0};
	char tank2D[] = {0,0,224,158,144,255,165,126};
	char sol[] = {255,54,235,150,114,91,199,84};
	char bombe1[] = {144,240,240,96,0,0,0,0};
	while(page<3)
	{
		Bdisp_AllClr_VRAM();
		if(page==0)
		{
			PrintMini(1, 1, "In this game, your tank is", 1);
			PrintMini(1, 7, "indestructable. You have to", 1);
			PrintMini(1, 13, "jump on enemies with their", 1);
			PrintMini(1, 19, "bombs to kill them.", 1);
			for(i=0 ; i<3 ; i++)
				DrawSprite8(sol, 8*i+8, 56);
			DrawSprite8(helico1D, 20, 27);
			DrawSprite8(bombe1, 17, 43);
			DrawSprite8(tank, 12, 48);
			for(i=0 ; i<3 ; i++)
				DrawSprite8(sol, 8*i+48, 56);
			DrawSprite8(helico1D, 60, 27);
			DrawSprite8(tank, 54, 42);
			for(i=0 ; i<3 ; i++)
				DrawSprite8(sol, 8*i+88, 56);
			DrawSprite8(helico1D, 100, 27);
			DrawSprite8(tank, 96, 31);
		}
		if(page==1)
		{
			PrintMini(1, 1, "There are two gauges on the", 1);
			PrintMini(1, 7, "right of the screen.", 1);
			PrintMini(1, 13, "The left one is the fuel,", 1);
			PrintMini(1, 19, "and the right one is yours", 1);
			PrintMini(1, 25, "experiences points.", 1);
			PrintMini(1, 37, "The fuel decreases regularly", 1);
			PrintMini(1, 43, "and the xp increases when", 1);
			PrintMini(1, 49, "you hit ennemys.", 1);
			dessinJauges(80, 30);
		}
		if(page==2)
		{
			PrintMini(1, 1, "Ennemy - xp point - weapon", 1);
			DrawSprite8(helico1D, 8, 10); PrintMini(52, 10, "20       bomb", 1);
			DrawSprite8(avion1D, 8, 20); PrintMini(52, 20, "30   bouncing bomb", 1);
			DrawSprite8(helico2D, 8, 30); PrintMini(52, 30, "40      missile", 1);
			DrawSprite8(avion2D, 8, 40); PrintMini(52, 40, "50   homing missile", 1);
			DrawSprite8(tank2D, 8, 50); PrintMini(52, 50, "20       none", 1);
		}
		GetKey(&key);
		switch(key)
		{
			case KEY_CTRL_EXE:
			case KEY_CTRL_RIGHT:
				page++;
				break;
			case KEY_CTRL_LEFT:
				if(page) page--;
		}
	}
}

void clearMenu()
{
	int i, image[] = {0,0,0,0,0,0,0,0,0x3FFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFC0,0xFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFF0,0x1F000000,0,0,0xF8,0x1C000000,0,0,0x38,0x38000000,0,0,0x1C,0x38000000,0,0,0x1C,0x30007FA2,0xF3EFBEF4,0x5F7DF7FB,0xE8A2000C,0x30008055,0xC10410A,0xA0820804,0x1555000C,0x3000804D,0x65F3776A,0xAEEEE805,0xD35A000C,0x300073D5,0x5448950A,0xA92AAF3C,0x1544000C,0x30001259,0x65F6555B,0xAEAAE925,0xD65A000C,0x30001255,0xC105568,0x20AA0925,0x5555000C,0x30001222,0xF3EF8897,0xDF11F122,0x28A2000C,0x30007380,0,0x120,0xC,0x30008040,0,0x120,0xC,0x30008040,0,0x120,0xC,0x30007F80,0,0xC0,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0x7FFFFF,0xFFFFFE00,0xC,0x30000000,0xFF8000,0x1FF00,0xC,0x30000000,0x1FF0000,0xFF80,0xC,0x30000000,0x1FF0000,0xFF80,0xC,0x30000000,0x1FF0000,0xFF80,0xC,0x30000000,0x1FF0000,0xFF80,0xC,0x30000000,0x1FF0000,0xFF80,0xC,0x30000000,0xFF8000,0x1FF00,0xC,0x30000000,0x7FFFFF,0xFFFFFE00,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0xE85,0x74600000,0xC,0x30000000,0x995,0x44500000,0xC,0x30000000,0xC87,0x64600000,0xC,0x30000000,0x9D5,0x77400000,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0,0,0xC,0x30000000,0xE400,0x220000,0xC,0x30000000,0x90C8,0x89220000,0xC,0x30000000,0xE5D5,0x55A20000,0xC,0x30000000,0x8511,0x15220000,0x144100C,0x30000000,0x84D1,0x8BB8000,0x14C300C,0x38000000,0,0,0x144101C,0x38000000,0,0,0x8EB81C,0x1C000000,0,0,0x38,0x1F000000,0,0,0xF8,0xFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFF0,0x3FFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFC0,0,0,0,0,0,0,0,0};
	char *vram, *buffer;
	vram = VRam_Base();
	buffer = (char*)image;
	for(i=0 ; i<1024 ; i++)
		vram[i] = buffer[i];
}

int AddIn_main(int isAppli, unsigned short OptionNum)
{
	int niveau = 0, key;
	char flecheGauche[] = {32,120,248,120,32,0,0,0};
	char flecheDroite[] = {32,240,248,240,32,0,0,0};
	char croix[] = {136,80,32,80,136,0,0,0};
	srand(time());
    while(1)
    {
		clearMenu();
		switch(niveau)
		{
			case 0: PrintMini(50, 27, "Novice", 1); break;
			case 1: PrintMini(50, 27, "Normal", 1); break;
			case 2: PrintMini(50, 27, "Insane", 1); break;
		}
		if(niveau > 0)	DrawSpriteReverse(flecheGauche, 41, 27);
		else			DrawSpriteReverse(croix, 41, 27);
		if(niveau < 2)	DrawSpriteReverse(flecheDroite, 82, 27);
		else			DrawSpriteReverse(croix, 82, 27);
		GetKey(&key);
		switch(key)
		{
			case KEY_CTRL_LEFT:
				if(niveau) niveau--;
				break;
			case KEY_CTRL_RIGHT:
				if(niveau<2) niveau++;
				break;
			case KEY_CTRL_F1: help(); break;
			case KEY_CTRL_EXE: jeu(niveau);
		}
    }
    return 1;
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section
